local Difficulty = settings.startup["WD_difficulty"].value
local levels = settings.startup["WD_waves"].value
--local constant_difficulty = settings.global["WD_constant_difficulty"].value
--local exponential_difficulty = settings.global["WD_exponential_difficulty"].value
local constant_difficulty = 300
local exponential_difficulty = 1.1
local maxhp = ((levels-16)*constant_difficulty+4000*math.pow(exponential_difficulty,levels-16))*Difficulty
levels = math.floor(math.log(maxhp / 160000)/math.log(2)+0.99)+6


function spitter_attack_parameters(data)
  return
  {
    type = "projectile",
    ammo_category = "rocket",
    cooldown = data.cooldown,
    range = data.range,
    min_attack_distance = data.min_attack_distance,
    projectile_creation_distance = 1.9,
    damage_modifier = data.damage_modifier,
    warmup = 30,
    ammo_type =
    {
      category = "biological",
      action =
      {
        type = "direct",
        action_delivery =
        {
          type = "projectile",
          projectile = "acid-projectile-purple",
          starting_speed = 0.5,
          max_range = data.range*2
        }
      }
    },
    sound = make_spitter_roars(data.roarvolume),
    animation = spitterattackanimation(data.scale, data.tint),
  }
end
local behemoth_spitter_attack =  {
      range=16,
      min_attack_distance=10,
      cooldown=100,
      damage_modifier=5,
      scale=1.3,
      tint={r=1.0, g=0.85, b=0.3, a=1.0},
      roarvolume=0.8
    }
local mk2_scale = 1.3
local mk2_tint1 = {r=1.0, g=0.85, b=0.3, a=1.0}
local mk2_tint2 = {r=0.88, g=0.44, b=0.24, a=1.0}
local mk3_scale = 1.3
local mk3_tint1 = {r=1.0, g=0.3, b=0.3, a=1.0}
local mk3_tint2 = {r=1.0, g=0.94, b=0.34, a=1.0}
local mk4_scale = 1.3
local mk4_tint1 = {r=1.0, g=0.4, b=1.0, a=1.0}
local mk4_tint2 = {r=1.0, g=0.34, b=0.34, a=1.0}
local mk5_scale = 1.3
local mk5_tint1 = {r=1.0, g=1.0, b=1.0, a=1.0}
local mk5_tint2 = {r=1.0, g=1.0, b=1.0, a=1.0}

function Biter_Melee_Attack(damage)
  return
  {
    category = "melee",
    target_type = "entity",
    action =
    {
      type = "direct",
      action_delivery =
      {
        type = "instant",
        target_effects =
        {
          type = "damage",
          damage = { amount = damage , type = "physical"}
        },
      }
    }
  }
end
-------------------------------
Damage = {
	Small_Biter = Biter_Melee_Attack(10*Difficulty),
	Medium_Biter = Biter_Melee_Attack(35*Difficulty),
	Big_Biter = Biter_Melee_Attack(80*Difficulty),
	Behemoth_Biter = Biter_Melee_Attack(175*Difficulty),
	Behemoth_Biter_Mk2 = Biter_Melee_Attack(175*Difficulty),
	Behemoth_Biter_Mk3 = Biter_Melee_Attack(175*Difficulty),
	Behemoth_Biter_Mk4 = Biter_Melee_Attack(175*Difficulty),
	Behemoth_Biter_Mk5 = Biter_Melee_Attack(175*Difficulty)
	}
	
	
Health = {
	Small_Biter = 30*Difficulty,
	Medium_Biter = 150*Difficulty,
	Big_Biter = 900*Difficulty,
	Behemoth_Biter = 10000,
	Behemoth_Biter_Mk2 = 20000,
	Behemoth_Biter_Mk3 = 40000,
	Behemoth_Biter_Mk4 = 80000,
	Behemoth_Biter_Mk5 = 160000,
	Small_Spitter = 20*Difficulty,
	Medium_Spitter = 100*Difficulty,
	Big_Spitter = 400*Difficulty,
	Behemoth_Spitter = 5000,
	Behemoth_Spitter_Mk2 = 10000,	
	Behemoth_Spitter_Mk3 = 20000,	
	Behemoth_Spitter_Mk4 = 40000,
	Behemoth_Spitter_Mk5 = 80000
	}



Resistances = {
	Small_Biter = {
	  {type = "fire", decrease = 5+2*2*(Difficulty-1), percent = 90+5*2*(Difficulty-1)},
      {type = "physical", decrease = 1, percent = 5+5*2*(Difficulty-1)},
      {type = "impact", decrease = 0, percent = 0},
      {type = "explosion", decrease = 0, percent = 0},
      {type = "acid", decrease = 0, percent = 0},
      {type = "poison", decrease = 0, percent = 2+2*2*(Difficulty-1)},
      {type = "laser", decrease = 0, percent = 3+3*2*(Difficulty-1)}},
	
	Medium_Biter = {
	  {type = "fire", decrease = 5+2*2*(Difficulty-1), percent = 83+5*2*(Difficulty-1)},
      {type = "physical", decrease = 6, percent = 10+5*2*(Difficulty-1)},
      {type = "impact", decrease = 4, percent = 0},
      {type = "explosion", decrease = 4, percent = 27+7*2*(Difficulty-1)},
      {type = "acid", decrease = 0, percent = 0},
      {type = "poison", decrease = 4, percent = 2+2*2*(Difficulty-1)},
      {type = "laser", decrease = 4, percent = 3+3*2*(Difficulty-1)}},
	
	
	Big_Biter = {
	  {type = "fire", decrease = 5+2*2*(Difficulty-1), percent = 73+5*2*(Difficulty-1)},
      {type = "physical", decrease = 14, percent = 15+8*2*(Difficulty-1)},
      {type = "impact", decrease = 10, percent = 0},
      {type = "explosion", decrease = 10, percent = 37+7*2*(Difficulty-1)},
      {type = "acid", decrease = 0, percent = 0},
      {type = "poison", decrease = 10, percent = 2+2*2*(Difficulty-1)},
      {type = "laser", decrease = 10, percent = 3+3*2*(Difficulty-1)}},
	
	
	Behemoth_Biter = {
	  {type = "fire", decrease = 5+2*2*(Difficulty-1), percent = 74+4*2*(Difficulty-1)},
      {type = "physical", decrease = 8+2*(Difficulty-1), percent = 11+8*2*(Difficulty-1)},
      {type = "impact", decrease = 16, percent = 0},
      {type = "explosion", decrease = 8, percent = 55+5*2*(Difficulty-1)},
      {type = "acid", decrease = 0, percent = 0},
      {type = "poison", decrease = 0, percent = -50},
      {type = "laser", decrease = 5+2*(Difficulty-1), percent = 3+8*2*(Difficulty-1)}},	
	  
	  Behemoth_Biter_Mk2 = {
	  {type = "fire", decrease = 6+2*2*(Difficulty-1), percent = 75+4*2*(Difficulty-1)},
      {type = "physical", decrease = 8+2*(Difficulty-1), percent = 11+8*2*(Difficulty-1)},
      {type = "impact", decrease = 16, percent = 0},
      {type = "explosion", decrease = 8, percent = 55+5*2*(Difficulty-1)},
      {type = "acid", decrease = 0, percent = 0},
      {type = "poison", decrease = 0, percent = -100},
      {type = "laser", decrease = 5+2*(Difficulty-1), percent = 3+8*2*(Difficulty-1)}},
	  
	Behemoth_Biter_Mk3 = {
	  {type = "fire", decrease = 7+2*2*(Difficulty-1), percent = 76+4*2*(Difficulty-1)},
      {type = "physical", decrease = 8+2*(Difficulty-1), percent = 11+8*2*(Difficulty-1)},
      {type = "impact", decrease = 16, percent = 0},
      {type = "explosion", decrease = 8, percent = 55+5*2*(Difficulty-1)},
      {type = "acid", decrease = 0, percent = 0},
      {type = "poison", decrease = 0, percent = -150},
      {type = "laser", decrease = 5+2*(Difficulty-1), percent = 3+8*2*(Difficulty-1)}},
	  
	Behemoth_Biter_Mk4 = {
	  {type = "fire", decrease = 8+2*2*(Difficulty-1), percent = 77+4*2*(Difficulty-1)},
      {type = "physical", decrease = 8+2*(Difficulty-1), percent = 11+8*2*(Difficulty-1)},
      {type = "impact", decrease = 16, percent = 0},
      {type = "explosion", decrease = 8, percent = 55+5*2*(Difficulty-1)},
      {type = "acid", decrease = 0, percent = 0},
      {type = "poison", decrease = 0, percent = -200},
      {type = "laser", decrease = 5+2*(Difficulty-1), percent = 3+8*2*(Difficulty-1)}},
	  
	Behemoth_Biter_Mk5 = {
	  {type = "fire", decrease = 9+2*2*(Difficulty-1), percent = 78+4*2*(Difficulty-1)},
      {type = "physical", decrease = 8+2*(Difficulty-1), percent = 11+8*2*(Difficulty-1)},
      {type = "impact", decrease = 16, percent = 0},
      {type = "explosion", decrease = 8, percent = 55+5*2*(Difficulty-1)},
      {type = "acid", decrease = 0, percent = 0},
      {type = "poison", decrease = 0, percent = -250},
      {type = "laser", decrease = 5+2*(Difficulty-1), percent = 3+8*2*(Difficulty-1)}},
	
	Small_Spitter = {
	  {type = "fire", decrease = 5+2*2*(Difficulty-1), percent = 95+10*2*(Difficulty-1)},
      {type = "physical", decrease = 1, percent = 5+5*2*(Difficulty-1)},
      {type = "impact", decrease = 0, percent = 0},
      {type = "explosion", decrease = 0, percent = 0},
      {type = "acid", decrease = 0, percent = 0},
      {type = "poison", decrease = 0, percent = 2+2*2*(Difficulty-1)},
      {type = "laser", decrease = 0, percent = 3+3*2*(Difficulty-1)}},
	
	Medium_Spitter = {
	  {type = "fire", decrease = 5, percent = 75+10*2*(Difficulty-1)},
      {type = "physical", decrease = 4, percent = 10+5*2*(Difficulty-1)},
      {type = "impact", decrease = 3, percent = 0},
      {type = "explosion", decrease = 3, percent = 27+7*2*(Difficulty-1)},
      {type = "acid", decrease = 0, percent = 0},
      {type = "poison", decrease = 3, percent = 2+2*2*(Difficulty-1)},
      {type = "laser", decrease = 3, percent = 3+3*2*(Difficulty-1)}},
	Big_Spitter = {
	  {type = "fire", decrease = 5+2*2*(Difficulty-1), percent = 78+10*2*(Difficulty-1)},
      {type = "physical", decrease = 8, percent = 15+8*2*(Difficulty-1)},
      {type = "impact", decrease = 6, percent = 0},
      {type = "explosion", decrease = 6, percent = 37+7*2*(Difficulty-1)},
      {type = "acid", decrease = 0, percent = 0},
      {type = "poison", decrease = 6, percent = 2+2*2*(Difficulty-1)},
      {type = "laser", decrease = 6, percent = 3+3*2*(Difficulty-1)}},
	
	Behemoth_Spitter = {
	  {type = "fire", decrease = 5+2*2*(Difficulty-1), percent = 81+4*2*(Difficulty-1)},
      {type = "physical", decrease = 7+2*(Difficulty-1), percent = 11+8*2*(Difficulty-1)},
      {type = "impact", decrease = 10, percent = 0},
      {type = "explosion", decrease = 5, percent = 65+5*2*(Difficulty-1)},
      {type = "acid", decrease = 0, percent = 0},
      {type = "poison", decrease =0 , percent = -25},
      {type = "laser", decrease = 4+2*(Difficulty-1), percent = 3+8*2*(Difficulty-1)}},
	  
	Behemoth_Spitter_Mk2 = {
	  {type = "fire", decrease = 6+2*2*(Difficulty-1), percent = 82+4*2*(Difficulty-1)},
      {type = "physical", decrease = 7+2*(Difficulty-1), percent = 11+8*2*(Difficulty-1)},
      {type = "impact", decrease = 10, percent = 0},
      {type = "explosion", decrease = 5, percent = 65+5*2*(Difficulty-1)},
      {type = "acid", decrease = 0, percent = 0},
      {type = "poison", decrease = 0, percent = -50},
      {type = "laser", decrease = 4+2*(Difficulty-1), percent = 3+8*2*(Difficulty-1)}},
	  
	Behemoth_Spitter_Mk3 = {
	  {type = "fire", decrease = 7+2*2*(Difficulty-1), percent = 83+4*2*(Difficulty-1)},
      {type = "physical", decrease = 7+2*(Difficulty-1), percent = 11+8*2*(Difficulty-1)},
      {type = "impact", decrease = 10, percent = 0},
      {type = "explosion", decrease = 5, percent = 65+5*2*(Difficulty-1)},
      {type = "acid", decrease = 0, percent = 0},
      {type = "poison", decrease = 0, percent = -75},
      {type = "laser", decrease = 4+2*(Difficulty-1), percent = 3+8*2*(Difficulty-1)}},
	  
	Behemoth_Spitter_Mk4 = {
	  {type = "fire", decrease = 8+2*2*(Difficulty-1), percent = 84+4*2*(Difficulty-1)},
      {type = "physical", decrease = 7+2*(Difficulty-1), percent = 11+8*2*(Difficulty-1)},
      {type = "impact", decrease = 10, percent = 0},
      {type = "explosion", decrease = 5, percent = 65+5*2*(Difficulty-1)},
      {type = "acid", decrease = 0, percent = 0},
      {type = "poison", decrease = 0, percent = -100},
      {type = "laser", decrease = 4+2*(Difficulty-1), percent = 3+8*2*(Difficulty-1)}},
	  
	Behemoth_Spitter_Mk5 = {
	  {type = "fire", decrease = 9+2*2*(Difficulty-1), percent = 85+4*2*(Difficulty-1)},
      {type = "physical", decrease = 7+2*(Difficulty-1), percent = 11+8*2*(Difficulty-1)},
      {type = "impact", decrease = 10, percent = 0},
      {type = "explosion", decrease = 5, percent = 65+5*2*(Difficulty-1)},
      {type = "acid", decrease = 0, percent = 0},
      {type = "poison", decrease = 0, percent = -125},
      {type = "laser", decrease = 4+2*(Difficulty-1), percent = 3+8*2*(Difficulty-1)}},
}
	  
	  
	  -----------

local biter1 = util.table.deepcopy(data.raw.unit["small-biter"])
biter1.name = "wd-small-biter"
biter1.resistances = Resistances.Small_Biter
biter1.max_health = Health.Small_Biter
biter1.ammo_type = Damage.Small_Biter
local biter2 = util.table.deepcopy(data.raw.unit["medium-biter"])
biter2.name = "wd-medium-biter"
biter2.resistances = Resistances.Medium_Biter
biter2.max_health = Health.Medium_Biter
biter2.ammo_type = Damage.Medium_Biter
local biter3 = util.table.deepcopy(data.raw.unit["big-biter"])
biter3.name = "wd-big-biter"
biter3.resistances = Resistances.Big_Biter
biter3.max_health = Health.Big_Biter
biter3.ammo_type = Damage.Big_Biter
local biter4 = util.table.deepcopy(data.raw.unit["behemoth-biter"])
biter4.name = "wd-behemoth-biter"
biter4.resistances = Resistances.Behemoth_Biter
biter4.max_health = Health.Behemoth_Biter
biter4.ammo_type = Damage.Behemoth_Biter
biter4.healing_per_tick = 0.01
local biter5 = util.table.deepcopy(data.raw.unit["behemoth-biter"])
biter5.name = "wd-behemoth-biter-mk2"
biter5.resistances = Resistances.Behemoth_Biter_Mk2
biter5.max_health = Health.Behemoth_Biter_Mk2
biter5.ammo_type = Damage.Behemoth_Biter_Mk2
biter5.healing_per_tick = 0.01
biter5.run_animation = biterrunanimation(mk2_scale, mk2_tint1, mk2_tint2)
biter5.attack_parameters.animation = biterattackanimation(mk2_scale, mk2_tint1, mk2_tint2)
biter5.corpse = "wd-behemoth-biter-corpse-mk2"
local biter6 = util.table.deepcopy(data.raw.unit["behemoth-biter"])
biter6.name = "wd-behemoth-biter-mk3"
biter6.resistances = Resistances.Behemoth_Biter_Mk3
biter6.max_health = Health.Behemoth_Biter_Mk3
biter6.ammo_type = Damage.Behemoth_Biter_Mk3
biter6.healing_per_tick = 0.01
biter6.run_animation = biterrunanimation(mk3_scale, mk3_tint1, mk3_tint2)
biter6.attack_parameters.animation = biterattackanimation(mk3_scale, mk3_tint1, mk3_tint2)
biter6.corpse = "wd-behemoth-biter-corpse-mk3"
local biter7 = util.table.deepcopy(data.raw.unit["behemoth-biter"])
biter7.name = "wd-behemoth-biter-mk4"
biter7.resistances = Resistances.Behemoth_Biter_Mk4
biter7.max_health = Health.Behemoth_Biter_Mk4
biter7.ammo_type = Damage.Behemoth_Biter_Mk4
biter7.healing_per_tick = 0.01
biter7.run_animation = biterrunanimation(mk4_scale, mk4_tint1, mk4_tint2)
biter7.attack_parameters.animation = biterattackanimation(mk4_scale, mk4_tint1, mk4_tint2)
biter7.corpse = "wd-behemoth-biter-corpse-mk4"
local biter8 = util.table.deepcopy(data.raw.unit["behemoth-biter"])
biter8.name = "wd-behemoth-biter-mk5"
biter8.resistances = Resistances.Behemoth_Biter_Mk5
biter8.max_health = Health.Behemoth_Biter_Mk5
biter8.ammo_type = Damage.Behemoth_Biter_Mk5
biter8.healing_per_tick = 0.01
biter8.run_animation = biterrunanimation(mk5_scale, mk5_tint1, mk5_tint2)
biter8.attack_parameters.animation = biterattackanimation(mk5_scale, mk5_tint1, mk5_tint2)
biter8.corpse = "wd-behemoth-biter-corpse-mk5"

local spitter1 = util.table.deepcopy(data.raw.unit["small-spitter"])
spitter1.name = "wd-small-spitter"
spitter1.resistances = Resistances.Small_Spitter
spitter1.max_health = Health.Small_Spitter
spitter1.ammo_type = Damage.Small_Spitter
local spitter2 = util.table.deepcopy(data.raw.unit["medium-spitter"])
spitter2.name = "wd-medium-spitter"
spitter2.resistances = Resistances.Medium_Spitter
spitter2.max_health = Health.Medium_Spitter
spitter2.ammo_type = Damage.Medium_Spitter
local spitter3 = util.table.deepcopy(data.raw.unit["big-spitter"])
spitter3.name = "wd-big-spitter"
spitter3.resistances = Resistances.Big_Spitter
spitter3.max_health = Health.Big_Spitter
spitter3.ammo_type = Damage.Big_Spitter
local spitter4 = util.table.deepcopy(data.raw.unit["behemoth-spitter"])
spitter4.name = "wd-behemoth-spitter"
spitter4.resistances = Resistances.Behemoth_Spitter
spitter4.max_health = Health.Behemoth_Spitter
spitter4.ammo_type = Damage.Behemoth_Spitter
spitter4.healing_per_tick = 0.01
local spitter5 = util.table.deepcopy(data.raw.unit["behemoth-spitter"])
behemoth_spitter_attack.scale=mk2_scale
behemoth_spitter_attack.tint= mk2_tint1
spitter5.attack_parameters = spitter_attack_parameters(behemoth_spitter_attack)
spitter5.name = "wd-behemoth-spitter-mk2"
spitter5.resistances = Resistances.Behemoth_Spitter_Mk2
spitter5.max_health = Health.Behemoth_Spitter_Mk2
spitter5.ammo_type = Damage.Behemoth_Spitter_Mk2
spitter5.healing_per_tick = 0.01
spitter5.run_animation = spitterrunanimation(mk2_scale, mk2_tint1)
spitter5.corpse = "wd-behemoth-spitter-corpse-mk2"
local spitter6 = util.table.deepcopy(data.raw.unit["behemoth-spitter"])
behemoth_spitter_attack.scale=mk3_scale
behemoth_spitter_attack.tint= mk3_tint1
spitter6.attack_parameters = spitter_attack_parameters(behemoth_spitter_attack)
spitter6.name = "wd-behemoth-spitter-mk3"
spitter6.resistances = Resistances.Behemoth_Spitter_Mk3
spitter6.max_health = Health.Behemoth_Spitter_Mk3
spitter6.ammo_type = Damage.Behemoth_Spitter_Mk3
spitter6.healing_per_tick = 0.01
spitter6.run_animation = spitterrunanimation(mk3_scale, mk3_tint1)
spitter6.corpse = "wd-behemoth-spitter-corpse-mk3"
local spitter7 = util.table.deepcopy(data.raw.unit["behemoth-spitter"])
behemoth_spitter_attack.scale=mk4_scale
behemoth_spitter_attack.tint= mk4_tint1
spitter7.attack_parameters = spitter_attack_parameters(behemoth_spitter_attack)
spitter7.name = "wd-behemoth-spitter-mk4"
spitter7.resistances = Resistances.Behemoth_Spitter_Mk4
spitter7.max_health = Health.Behemoth_Spitter_Mk4
spitter7.ammo_type = Damage.Behemoth_Spitter_Mk4
spitter7.healing_per_tick = 0.01
spitter7.run_animation = spitterrunanimation(mk4_scale, mk4_tint1)
spitter7.corpse = "wd-behemoth-spitter-corpse-mk4"
local spitter8 = util.table.deepcopy(data.raw.unit["behemoth-spitter"])
behemoth_spitter_attack.scale=mk5_scale
behemoth_spitter_attack.tint= mk5_tint1
spitter8.attack_parameters = spitter_attack_parameters(behemoth_spitter_attack)
spitter8.name = "wd-behemoth-spitter-mk5"
spitter8.resistances = Resistances.Behemoth_Spitter_Mk5
spitter8.max_health = Health.Behemoth_Spitter_Mk5
spitter8.ammo_type = Damage.Behemoth_Spitter_Mk5
spitter8.healing_per_tick = 0.01
spitter8.run_animation = spitterrunanimation(mk5_scale, mk5_tint1)
spitter8.corpse = "wd-behemoth-spitter-corpse-mk5"

local bitercorpse5 =  util.table.deepcopy(data.raw.corpse["behemoth-biter-corpse"])
bitercorpse5.name = "wd-behemoth-biter-corpse-mk2"
bitercorpse5.animation = biterdieanimation(mk2_scale, mk2_tint1, mk2_tint2)
local bitercorpse6 = util.table.deepcopy(data.raw.corpse["behemoth-biter-corpse"])
bitercorpse6.name = "wd-behemoth-biter-corpse-mk3"
bitercorpse6.animation = biterdieanimation(mk3_scale, mk3_tint1, mk3_tint2)
local bitercorpse7 = util.table.deepcopy(data.raw.corpse["behemoth-biter-corpse"])
bitercorpse7.name = "wd-behemoth-biter-corpse-mk4"
bitercorpse7.animation = biterdieanimation(mk4_scale, mk4_tint1, mk4_tint2)
local bitercorpse8 = util.table.deepcopy(data.raw.corpse["behemoth-biter-corpse"])
bitercorpse8.name = "wd-behemoth-biter-corpse-mk5"
bitercorpse8.animation = biterdieanimation(mk5_scale, mk5_tint1, mk5_tint2)

local spittercorpse5 = util.table.deepcopy(data.raw.corpse["behemoth-spitter-corpse"])
spittercorpse5.name = "wd-behemoth-spitter-corpse-mk2"
spittercorpse5.animation = biterdieanimation(mk2_scale, mk2_tint1, mk2_tint2)
local spittercorpse6 = util.table.deepcopy(data.raw.corpse["behemoth-spitter-corpse"])
spittercorpse6.name = "wd-behemoth-spitter-corpse-mk3"
spittercorpse6.animation = biterdieanimation(mk3_scale, mk3_tint1, mk3_tint2)
local spittercorpse7 = util.table.deepcopy(data.raw.corpse["behemoth-spitter-corpse"])
spittercorpse7.name = "wd-behemoth-spitter-corpse-mk4"
spittercorpse7.animation = biterdieanimation(mk4_scale, mk4_tint1, mk4_tint2)
local spittercorpse8 = util.table.deepcopy(data.raw.corpse["behemoth-spitter-corpse"])
spittercorpse8.name = "wd-behemoth-spitter-corpse-mk5"
spittercorpse8.animation = biterdieanimation(mk5_scale, mk5_tint1, mk5_tint2)

local extend = {biter1,biter2,biter3,biter4,biter5,biter6,biter7,biter8,spitter1,spitter2,spitter3,spitter4,spitter5,spitter6,spitter7,spitter8,bitercorpse5,bitercorpse6,bitercorpse7,bitercorpse8,spittercorpse5,spittercorpse6,spittercorpse7,spittercorpse8}
local biterhealth = 160000
local spitterhealth = 80000
local scale = 1.3
local tint = 1

 for i=6, math.min(48,levels) do
	biterhealth = biterhealth * 2
	spitterhealth = spitterhealth * 2


	local biter = util.table.deepcopy(data.raw.unit["behemoth-biter"])
	biter.name = "wd-behemoth-biter-mk"..tostring(i)
	biter.resistances = Resistances.Behemoth_Biter_Mk5
	biter.max_health = biterhealth
	biter.ammo_type = Damage.Behemoth_Biter_Mk5
	biter.healing_per_tick = 0.01
	biter.run_animation = biterrunanimation(scale, {r=tint, g=tint, b=tint, a=1.0}, {r=tint, g=tint, b=tint, a=1.0})
	biter.attack_parameters.animation = biterattackanimation(scale, {r=tint, g=tint, b=tint, a=1.0}, {r=tint, g=tint, b=tint, a=1.0})
	biter.corpse = "wd-behemoth-biter-corpse-mk"..tostring(i)
table.insert(extend, biter)
	local spitter = util.table.deepcopy(data.raw.unit["behemoth-spitter"])
	behemoth_spitter_attack.scale=scale
	behemoth_spitter_attack.tint= {r=tint, g=tint, b=tint, a=1.0}
	spitter.attack_parameters = spitter_attack_parameters(behemoth_spitter_attack)
	spitter.name = "wd-behemoth-spitter-mk"..tostring(i)
	spitter.resistances = Resistances.Behemoth_Spitter_Mk5
	spitter.max_health = spitterhealth
	spitter.ammo_type = Damage.Behemoth_Spitter_Mk5
	spitter.healing_per_tick = 0.01
	spitter.run_animation = spitterrunanimation(scale, {r=tint, g=tint, b=tint, a=1.0})
	spitter.corpse = "wd-behemoth-spitter-corpse-mk"..tostring(i)
table.insert(extend, spitter)
	local bitercorpse = util.table.deepcopy(data.raw.corpse["behemoth-biter-corpse"])
	bitercorpse.name = "wd-behemoth-biter-corpse-mk"..tostring(i)
	bitercorpse.animation = biterdieanimation(scale, {r=tint, g=tint, b=tint, a=1.0}, {r=tint, g=tint, b=tint, a=1.0})
table.insert(extend, bitercorpse)
	local spittercorpse = util.table.deepcopy(data.raw.corpse["behemoth-spitter-corpse"])
	spittercorpse.name = "wd-behemoth-spitter-corpse-mk"..tostring(i)
	spittercorpse.animation = biterdieanimation(scale, {r=tint, g=tint, b=tint, a=1.0}, {r=tint, g=tint, b=tint, a=1.0})
table.insert(extend, spittercorpse)
	tint = tint-1/(levels-6)
	scale = scale + math.min(0.1,1/(levels-6))
end
data:extend(extend)
